/*
    File automatically generated by SOAdvancedDissector.py
    More information at http://indefero.soutade.fr/p/soadvanceddissector
*/

#ifndef _DPDOC_H
#define _DPDOC_H

#include <dp.h>
#include <dpsec.h>
#include <uft.h>
#include <dpdev.h>


namespace dpdoc {

    class Annot;
    class AnnotParameter;
    class Annotation;
    class AudioInfo;
    class ContentIterator;
    class DisplayElement;
    class DisplayHandler;
    class Document;
    class DocumentClient;
    class DocumentProvider;
    class Event;
    class ExternalLinkInfo;
    class KeyboardEvent;
    class LinkInfo;
    class Location;
    class Matrix;
    class MetadataItem;
    class MouseEvent;
    class MouseLocationInfo;
    class PageDecoration;
    class PageNumbers;
    class PermReqObj;
    class PermReqOpr;
    class Range;
    class RangeInfo;
    class Rectangle;
    class Renderer;
    class RendererClient;
    class Surface;
    class TOCItem;
    class TextEvent;
    class VideoInfo;


    class Annot
    {
    public:
        virtual void getSubtype() const = 0;
        virtual void getParams(uft::Dict&, dpdoc::AnnotParameter) const = 0;
        virtual void setParams(uft::Dict const&, dpdoc::AnnotParameter) = 0;

    };

    class AnnotParameter
    {
    public:
    };

    class Annotation
    {
    public:
        class StreamReader
        {
        public:
        };

        virtual void getPropertyType(dp::String const&) const = 0;
        virtual void getIntegerProperty(dp::String const&) const = 0;
        virtual void getRealProperty(dp::String const&) const = 0;
        virtual void getStringProperty(dp::String const&) const = 0;
        virtual void getNameProperty(dp::String const&) const = 0;
        virtual void setNameProperty(dp::String const&, dp::String const&) = 0;
        virtual void getBooleanProperty(dp::String const&) const = 0;
        virtual void getStreamProperty(dp::String const&, dpdoc::Annotation::StreamReader&) const = 0;
        virtual void setStreamProperty(dp::String const&, dp::String const&) const = 0;
        virtual void setStringProperty(dp::String const&, dp::String const&) const = 0;
        virtual void getArrayLength(dp::String const&) const = 0;
        virtual void getStringArrayProperty(dp::String const&, dp::String*) const = 0;

    };

    class AudioInfo
    {
    public:
    };

    class ContentIterator: public dp::Releasable
    {
    public:
        virtual ~ContentIterator();
        virtual void* getInterfaceID();
        virtual void release() = 0;
        virtual void next(unsigned int) = 0;
        virtual void previous(unsigned int) = 0;
        virtual void getCurrentPosition() = 0;

    };

    class DisplayElement: public dp::Unknown
    {
    public:
        virtual ~DisplayElement();
        virtual void* getInterfaceID();
        virtual void getType() = 0;
        virtual void getBeginning() = 0;
        virtual void getEnd() = 0;
        virtual void getBox(dpdoc::Rectangle*) = 0;
        virtual void getTransform(dpdoc::Matrix*) = 0;
        virtual void getEmbedURL() = 0;

    };

    class DisplayHandler: public dp::Unknown
    {
    public:
        virtual ~DisplayHandler();
        virtual void* getInterfaceID();
        virtual void startDisplayElement(dpdoc::DisplayElement*) = 0;
        virtual void endDisplayElement(dpdoc::DisplayElement*) = 0;

    };

    class Document: public dp::Releasable
    {
    public:
        virtual ~Document();
        virtual void* getInterfaceID();
        virtual void release() = 0;
        virtual void getInterfaceVersion() = 0;
        virtual void getNaturalUnit() = 0;
        virtual void setURL(dp::String const&) = 0;
        virtual void getMetadata(dp::String const&, int) = 0;
        virtual void getTocRoot() = 0;
        virtual void getBeginning() = 0;
        virtual void getEnd() = 0;
        virtual void getLocationFromBookmark(dp::String const&) = 0;
        virtual void findText(dp::ref<dpdoc::Location> const&, dp::ref<dpdoc::Location> const&, unsigned int, dp::String const&, dpdoc::Range*) = 0;
        virtual void getText(dp::ref<dpdoc::Location> const&, dp::ref<dpdoc::Location> const&) = 0;
        virtual void getPageCount() = 0;
        virtual void getLocationFromPagePosition(double) = 0;
        virtual void getPageName(double) = 0;
        virtual void getPagePosition(dp::String const&) = 0;
        virtual void setSyntheticPageInfo(int, int) = 0;
        virtual void setPageMapURL(dp::String const&) = 0;
        virtual void getContentIterator(int, dp::ref<dpdoc::Location> const&) = 0;
        virtual void createRenderer(dpdoc::RendererClient*) = 0;
        virtual void getErrorList() = 0;
        virtual void setDocumentPassword(dp::String const&) = 0;
        virtual void setLicense(dp::String const&, dp::String const&, dp::Data const&) = 0;
        virtual void serializeDocumentAndLicense() = 0;
        virtual void getRights() = 0;
        virtual void setContextDevice(dpdev::Device*) = 0;
        virtual void getPageProgressionDirection() = 0;
        virtual void createAnnot(uft::Dict const&);
        virtual void deleteAnnot(dpdoc::Annot*);
        virtual void updatePDF();
        virtual void getPermission(dpdoc::PermReqObj, dpdoc::PermReqOpr);

        void createDocument(dpdoc::DocumentClient*, dp::String const&);

        void* m_bPurgeFontsOnExit;
        void* m_dDocumentCount;

    };

    class DocumentClient: public dp::Unknown
    {
    public:
        DocumentClient();

        virtual ~DocumentClient();
        virtual void* getInterfaceID();
        virtual void getInterfaceVersion() = 0;
        virtual void getResourceStream(dp::String const&, unsigned int) = 0;
        virtual void canContinueProcessing(int) = 0;
        virtual void reportLoadingState(int) = 0;
        virtual void reportDocumentError(dp::String const&) = 0;
        virtual void reportErrorListChange() = 0;
        virtual void requestLicense(dp::String const&, dp::String const&, dp::Data const&) = 0;
        virtual void requestDocumentPassword() = 0;
        virtual void requestCredentials(dpsec::SecurityHandlerData*);
        virtual void documentSerialized() = 0;

    };

    class DocumentProvider: public dp::Unknown
    {
    public:
        virtual ~DocumentProvider();
        virtual void* getInterfaceID();
        virtual void createDocument(dpdoc::DocumentClient*, dp::String const&) = 0;

        void addProvider(dpdoc::DocumentProvider*);

    };

    class Event: public dp::Unknown
    {
    public:
        virtual ~Event();
        virtual void* getInterfaceID();
        virtual void getEventKind() = 0;
        virtual void getEventType() = 0;
        virtual void reject() = 0;

    };

    class ExternalLinkInfo
    {
    public:
    };

    class KeyboardEvent: public dpdoc::Event
    {
    public:
        virtual ~KeyboardEvent();
        virtual void* getInterfaceID();
        virtual void getEventKind() = 0;
        virtual void getEventType() = 0;
        virtual void reject() = 0;
        virtual void getKeyIdentifier() = 0;
        virtual void getModifiers() = 0;
        virtual void getKeyLocation() = 0;

    };

    class LinkInfo
    {
    public:
    };

    class Location: public dp::RefCounted
    {
    public:
        virtual ~Location();
        virtual void* getInterfaceID();
        virtual void addRef() = 0;
        virtual void release() = 0;
        virtual void setReturnEpubCfiBookmarks(bool);
        virtual void getReturnEpubCfiBookmarks();
        virtual void getBookmark() = 0;
        virtual void compare(dp::ref<dpdoc::Location> const&) = 0;
        virtual void getPagePosition() = 0;

    };

    class Matrix
    {
    public:
    };

    class MetadataItem: public dp::RefCounted
    {
    public:
        virtual ~MetadataItem();
        virtual void* getInterfaceID();
        virtual void addRef() = 0;
        virtual void release() = 0;
        virtual void getValue() = 0;
        virtual void getAttribute(dp::String const&, dp::String const&) = 0;

    };

    class MouseEvent: public dpdoc::Event
    {
    public:
        virtual ~MouseEvent();
        virtual void* getInterfaceID();
        virtual void getEventKind() = 0;
        virtual void getEventType() = 0;
        virtual void reject() = 0;
        virtual void getButton() = 0;
        virtual void getModifiers() = 0;
        virtual void getX() = 0;
        virtual void getY() = 0;

    };

    class MouseLocationInfo
    {
    public:
    };

    class PageDecoration
    {
    public:
    };

    class PageNumbers
    {
    public:
    };

    class PermReqObj
    {
    public:
    };

    class PermReqOpr
    {
    public:
    };

    class Range
    {
    public:
        ~Range();

    };

    class RangeInfo: public dp::Releasable
    {
    public:
        virtual ~RangeInfo();
        virtual void* getInterfaceID();
        virtual void release() = 0;
        virtual void startsBeforeThisScreen() = 0;
        virtual void endsBeforeThisScreen() = 0;
        virtual void startsAfterThisScreen() = 0;
        virtual void endsAfterThisScreen() = 0;
        virtual void getBoxCount() = 0;
        virtual void getBox(int, bool, dpdoc::Rectangle*) = 0;
        virtual void getBoxTransform(int, dpdoc::Matrix*) = 0;
        virtual void getBoxFlags(int, unsigned int*) = 0;

    };

    class Rectangle
    {
    public:
    };

    class Renderer: public dp::Releasable
    {
    public:
        virtual ~Renderer();
        virtual void* getInterfaceID();
        virtual void release() = 0;
        virtual void getInterfaceVersion() = 0;
        virtual void getCapabilities() = 0;
        virtual void navigateToLocation(dp::ref<dpdoc::Location> const&) = 0;
        virtual void getCurrentLocation() = 0;
        virtual void supportsPixelLayout(int) = 0;
        virtual void getScreenBeginning() = 0;
        virtual void getScreenEnd() = 0;
        virtual void getPageNumbersForScreen(dpdoc::PageNumbers*) = 0;
        virtual void getNaturalSize(dpdoc::Rectangle*) = 0;
        virtual void getMarkedArea(dpdoc::Rectangle*) = 0;
        virtual void setViewport(double, double, bool) = 0;
        virtual void setEnvironmentMatrix(dpdoc::Matrix const&) = 0;
        virtual void setNavigationMatrix(dpdoc::Matrix const&) = 0;
        virtual void getNavigationMatrix(dpdoc::Matrix*) = 0;
        virtual void paint(int, int, int, int, dpdoc::Surface*) = 0;
        virtual void paint(dpdoc::Matrix const&, int, int, int, int, dpdoc::Surface*, int);
        virtual void paint(dpdoc::Matrix const&, int, int, int, int, dpdoc::Surface*, int, int);
        virtual void hasOverlayContent(dpdoc::Matrix const&, int, int, int, int, int);
        virtual void walkScreen(dpdoc::DisplayHandler*, unsigned int) = 0;
        virtual void handleEvent(dpdoc::Event*) = 0;
        virtual void hitTest(double, double, unsigned int) = 0;
        virtual void hitTestForAnnotation(double, double, int, uft::Dict&);
        virtual void hitTestForAnnotation(double const*, double*, dp::String&);
        virtual void getAnnotationBounds(dpdoc::Annotation*, double*);
        virtual void isFocusable() = 0;
        virtual void getPagingMode() = 0;
        virtual void setPagingMode(int) = 0;
        virtual void setPageDecoration(dpdoc::PageDecoration const&) = 0;
        virtual void nextScreen() = 0;
        virtual void previousScreen() = 0;
        virtual void isAtBeginning() = 0;
        virtual void isAtEnd() = 0;
        virtual void getDefaultFontSize() = 0;
        virtual void setDefaultFontSize(double) = 0;
        virtual void addHighlight(int, dp::ref<dpdoc::Location> const&, dp::ref<dpdoc::Location> const&) = 0;
        virtual void setHighlightColor(int, int, unsigned int) = 0;
        virtual void getHighlightColor(int, int) = 0;
        virtual void navigateToHighlight(int, int) = 0;
        virtual void getHighlightCount(int) = 0;
        virtual void getHighlight(int, int, dpdoc::Range*) = 0;
        virtual void removeHighlight(int, int) = 0;
        virtual void removeAllHighlights(int) = 0;
        virtual void getLinkCount() = 0;
        virtual void getLinkInfo(int, dpdoc::LinkInfo*) = 0;
        virtual void getExternalLinkCount() = 0;
        virtual void getExternalLinkInfo(int, dpdoc::ExternalLinkInfo*) = 0;
        virtual void getRangeInfo(dp::ref<dpdoc::Location> const&, dp::ref<dpdoc::Location> const&) = 0;
        virtual void setMargins(double, double, double, double) = 0;
        virtual void setCSSMediaType(dp::String const&) = 0;
        virtual void getVideoCountForCurrentScreen() = 0;
        virtual void getVideoInfoForVideoOnCurrentScreen(int, dpdoc::VideoInfo*) = 0;
        virtual void getAudioCountForCurrentScreen() = 0;
        virtual void getAudioInfoForAudioOnCurrentScreen(int, dpdoc::AudioInfo*) = 0;
        virtual void setPlayMode(unsigned int) = 0;
        virtual void getPlayMode() = 0;
        virtual void showPageNumbers(bool) = 0;
        virtual void allowExternalLinks(bool) = 0;
        virtual void hibernate() = 0;
        virtual void wakeUp() = 0;
        virtual void performAction(dp::String const&) = 0;
        virtual void reflowFailed();
        virtual void convertPointFromDeviceSpaceToDocumentSpace(double, double, double&, double&, int);
        virtual void convertPointFromDocumentSpaceToDeviceSpace(double, double, double&, double&, int);
        virtual void convertPointFromDocumentSpaceToDeviceSpace(double, double, double&, double&, int, int, dpdoc::Matrix const&);
        virtual void getWordBoundary(double, double, unsigned int, dpdoc::Location**, dpdoc::Location**, dpdoc::Location**, double*, double*, int, bool);
        virtual void updateTextSelection(dpdoc::Location*, bool);
        virtual void getVideoInfoForCurrentScreenAsJSON() = 0;
        virtual void getAudioInfoForCurrentScreenAsJSON() = 0;
        virtual void getVideoStream(dp::String) = 0;
        virtual void getAudioStream(dp::String) = 0;

    };

    class RendererClient: public dp::Unknown
    {
    public:
        virtual ~RendererClient();
        virtual void* getInterfaceID();
        virtual void getInterfaceVersion() = 0;
        virtual void getUnitsPerInch() = 0;
        virtual void getPageMarginFontSize() = 0;
        virtual void requestRepaint(int, int, int, int) = 0;
        virtual void requestHighlightRepaint(int, int, int, int);
        virtual void navigateToURL(dp::String const&, dp::String const&) = 0;
        virtual void reportMouseLocationInfo(dpdoc::MouseLocationInfo const&) = 0;
        virtual void reportInternalNavigation() = 0;
        virtual void reportDocumentSizeChange() = 0;
        virtual void reportHighlightChange(int) = 0;
        virtual void reportRendererError(dp::String const&) = 0;
        virtual void finishedPlaying() = 0;
        virtual void doIntermediateBlit(dpdoc::Surface*);

    };

    class Surface: public dp::Unknown
    {
    public:
        virtual ~Surface();
        virtual void* getInterfaceID();
        virtual void getSurfaceKind() = 0;
        virtual void getPixelLayout() = 0;
        virtual void getTransferMap(int) = 0;
        virtual void getDitheringClipMap(int) = 0;
        virtual void getDitheringDepth(int) = 0;
        virtual void checkOut(int, int, int, int, unsigned int*) = 0;
        virtual void checkIn(unsigned char*) = 0;

        void initDitheringClipMap(unsigned char*, int);

    };

    class TOCItem: public dp::Releasable
    {
    public:
        virtual ~TOCItem();
        virtual void* getInterfaceID();
        virtual void release() = 0;
        virtual void getTitle() = 0;
        virtual void getLocation() = 0;
        virtual void getChildCount() = 0;
        virtual void getChild(int) = 0;

    };

    class TextEvent: public dpdoc::Event
    {
    public:
        virtual ~TextEvent();
        virtual void* getInterfaceID();
        virtual void getEventKind() = 0;
        virtual void getEventType() = 0;
        virtual void reject() = 0;
        virtual void getData() = 0;

    };

    class VideoInfo
    {
    public:
    };


}



#endif // _DPDOC_H
