/*
    File automatically generated by SOAdvancedDissector.py
    More information at http://indefero.soutade.fr/p/soadvanceddissector
*/

#ifndef _DPLIB_H
#define _DPLIB_H

#include <dp.h>
#include <mdom.h>
#include <uft.h>
#include <dpdev.h>
#include <dptimer.h>
#include <dpio.h>


namespace dplib {

    class ContentRecord;
    class LibraryItem;
    class ContentRecordImpl;
    class ContentRecordList;
    class ContentTag;
    class ContentTagImpl;
    //class CreateUniqueFileCallback<dplib::ContentRecordImpl>;
    //class CreateUniqueFileCallback<dplib::ContentTagImpl>;
    class Library;
    class LibraryDeviceListener;
    class LibraryImpl;
    //class RemoveFileCallback<dplib::ContentRecordImpl>;
    //class RemoveFileCallback<dplib::ContentTagImpl>;
    class TagList;
    //class WriteFileCallback<dplib::ContentRecordImpl>;
    //class WriteFileCallback<dplib::ContentTagImpl>;

    class LibraryListener {};

    class ContentRecord: public dp::RefCounted
    {
    public:
        virtual ~ContentRecord();
        virtual void* getInterfaceID();
        virtual void addRef() = 0;
        virtual void release() = 0;
        virtual void getLibrary() = 0;
        virtual void getMetadata(dp::String const&) = 0;
        virtual void setMetadata(dp::String const&, dp::String const&) = 0;
        virtual void getCreationTime() = 0;
        virtual void getLastReadTime() = 0;
        virtual void getLastReadBookmark() = 0;
        virtual void setLastReadBookmark(dp::String const&) = 0;
        virtual void getPrivateData(dp::String const&, dp::String const&) = 0;
        virtual void setPrivateData(dp::String const&, dp::String const&, dp::String const&) = 0;
        virtual void getContentURL() = 0;
        virtual void getThumbnailURL() = 0;
        virtual void thumbnailChangeNotify() = 0;
        virtual void getAnnotationURL() = 0;
        virtual void annotationChangeNotify() = 0;
        virtual void isTaggedBy(dp::ref<dplib::ContentTag> const&) = 0;
        virtual void addTag(dp::ref<dplib::ContentTag> const&) = 0;
        virtual void removeTag(dp::ref<dplib::ContentTag> const&) = 0;
        virtual void getTags() = 0;

    };

    class LibraryItem
    {
    public:
        LibraryItem(dplib::LibraryImpl*, uft::String const&, bool);

        ~LibraryItem();

        virtual void virtfunc8() = 0;

        void ensureNodeExists(unsigned int);
        void getBaseLocalPath();
        void getFirstChildNodeWithType(mdom::Node const&, unsigned int);
        void getFirstNodeWithType(unsigned int);
        void getMetadata(dp::String const&);
        void getMetadataNode(uft::String const&);
        void getMetadataNodeType(uft::String const&);
        void getPrivateData(dp::String const&, dp::String const&);
        void getPrivateDataNode(mdom::Node const&, uft::QName);
        void loadXML(unsigned int, dp::Data const&);
        void serializeToXML();
        void setMetadata(dp::String const&, dp::String const&);
        void setNodeText(mdom::Node const&, uft::String const&);
        void setPrivateData(dp::String const&, dp::String const&, dp::String const&);
        void setTextValue(unsigned int, unsigned int, uft::String const&);

    };

    class ContentRecordImpl: public dplib::ContentRecord, public dplib::LibraryItem
    {
    public:
        ContentRecordImpl(dplib::LibraryImpl*, uft::String const&, dp::Data const&);
        ContentRecordImpl(dplib::LibraryImpl*, uft::String const&, uft::String const&, dplib::ContentRecordImpl*);

        virtual ~ContentRecordImpl();
        virtual void* getInterfaceID();
        virtual void addRef();
        virtual void release();
        virtual void getLibrary();
        virtual void getMetadata(dp::String const&);
        virtual void setMetadata(dp::String const&, dp::String const&);
        virtual void getCreationTime();
        virtual void getLastReadTime();
        virtual void getLastReadBookmark();
        virtual void setLastReadBookmark(dp::String const&);
        virtual void getPrivateData(dp::String const&, dp::String const&);
        virtual void setPrivateData(dp::String const&, dp::String const&, dp::String const&);
        virtual void getContentURL();
        virtual void getThumbnailURL();
        virtual void thumbnailChangeNotify();
        virtual void getAnnotationURL();
        virtual void annotationChangeNotify();
        virtual void isTaggedBy(dp::ref<dplib::ContentTag> const&);
        virtual void addTag(dp::ref<dplib::ContentTag> const&);
        virtual void removeTag(dp::ref<dplib::ContentTag> const&);
        virtual void getTags();
        virtual void setDirty();

        void loadXML(dp::Data const&);
        void staticInit();

        void* s_descriptor;

    };

    class ContentRecordList: public dp::List<dplib::ContentRecord>
    {
    public:
        virtual ~ContentRecordList();
        virtual void addRef();
        virtual void release();
        virtual void length();
        virtual void operator[](unsigned int);

    };

    class ContentTag: public dp::RefCounted
    {
    public:
        virtual ~ContentTag();
        virtual void* getInterfaceID();
        virtual void addRef() = 0;
        virtual void release() = 0;
        virtual void getLibrary() = 0;
        virtual void getMetadata(dp::String const&) = 0;
        virtual void setMetadata(dp::String const&, dp::String const&) = 0;
        virtual void getTagID() = 0;
        virtual void getParent() = 0;
        virtual void getPrivateData(dp::String const&, dp::String const&) = 0;
        virtual void setPrivateData(dp::String const&, dp::String const&, dp::String const&) = 0;

    };

    class ContentTagImpl: public dplib::ContentTag, public dplib::LibraryItem
    {
    public:
        ContentTagImpl(dplib::LibraryImpl*, dplib::ContentTagImpl const&);
        ContentTagImpl(dplib::LibraryImpl*, uft::String const&, dp::Data const&);
        ContentTagImpl(dplib::LibraryImpl*, uft::String const&, uft::String const&);

        virtual ~ContentTagImpl();
        virtual void* getInterfaceID();
        virtual void addRef();
        virtual void release();
        virtual void getLibrary();
        virtual void getMetadata(dp::String const&);
        virtual void setMetadata(dp::String const&, dp::String const&);
        virtual void getTagID();
        virtual void getParent();
        virtual void getPrivateData(dp::String const&, dp::String const&);
        virtual void setPrivateData(dp::String const&, dp::String const&, dp::String const&);
        virtual void setDirty();

        void getFinalLeaf();
        void getParentTagID();
        void loadXML(dp::Data const&);
        void staticInit();

        void* s_descriptor;

    };

    // class CreateUniqueFileCallback<dplib::ContentRecordImpl>: public dp::Callback
    // {
    // public:
    //     virtual ~CreateUniqueFileCallback();
    //     virtual void reportError(dp::String const&);
    //     virtual void invoke(dp::Unknown*);

    // };

    // class CreateUniqueFileCallback<dplib::ContentTagImpl>: public dp::Callback
    // {
    // public:
    //     virtual ~CreateUniqueFileCallback();
    //     virtual void reportError(dp::String const&);
    //     virtual void invoke(dp::Unknown*);

    // };

    class Library: public dp::Unknown
    {
    public:
        virtual ~Library();
        virtual void* getInterfaceID();
        virtual dpio::Partition* getPartition() = 0;
        virtual bool isLoaded() = 0;
        virtual void createContentRecord(dp::String const&) = 0;
        virtual void cloneContentRecord(dp::ref<dplib::ContentRecord> const&, dp::String const&) = 0;
        virtual void getContentRecordByURL(dp::String const&) = 0;
        virtual void removeContentRecord(dp::ref<dplib::ContentRecord> const&) = 0;
        virtual void getTags(dp::ref<dplib::ContentTag> const&) = 0;
        virtual void getContentRecords(dp::ref<dplib::ContentTag> const&) = 0;
        virtual void getTagByID(dp::String const&) = 0;
        virtual void removeTag(dp::ref<dplib::ContentTag> const&) = 0;
        virtual void addListener(dplib::LibraryListener*) = 0;
        virtual void removeListener(dplib::LibraryListener*) = 0;

        void getPartitionLibrary(dpio::Partition*);

    };

    class LibraryDeviceListener: public dpdev::DeviceListener
    {
    public:
        virtual ~LibraryDeviceListener();
        virtual void reportError(int, int, dp::String const&);
        virtual void deviceKeyReady(int, int);
        virtual void deviceAdded(int, int, dpdev::Device*);
        virtual void deviceRemoved(int, int, dpdev::Device*);
        virtual void partitionAdded(int, int, int, dpio::Partition*);
        virtual void partitionRemoved(int, int, int, dpio::Partition*);

    };

    // class LibraryImpl: public dplib::Library, public dptimer::TimerClient
    // {
    // public:
    //     LibraryImpl(dpio::Partition*, uft::String const&);

    //     virtual ~LibraryImpl();
    //     virtual void* getInterfaceID();
    //     virtual void getPartition();
    //     virtual void isLoaded();
    //     virtual void createContentRecord(dp::String const&);
    //     virtual void cloneContentRecord(dp::ref<dplib::ContentRecord> const&, dp::String const&);
    //     virtual void getContentRecordByURL(dp::String const&);
    //     virtual void removeContentRecord(dp::ref<dplib::ContentRecord> const&);
    //     virtual void getTags(dp::ref<dplib::ContentTag> const&);
    //     virtual void getContentRecords(dp::ref<dplib::ContentTag> const&);
    //     virtual void getTagByID(dp::String const&);
    //     virtual void removeTag(dp::ref<dplib::ContentTag> const&);
    //     virtual void addListener(dplib::LibraryListener*);
    //     virtual void removeListener(dplib::LibraryListener*);
    //     virtual void timerFired(dptimer::Timer*);

    //     void addContentRecordToSave(dplib::ContentRecordImpl*);
    //     void addContentTagToSave(dplib::ContentTagImpl*);
    //     void addDirectoryToLoad(uft::String const&);
    //     void addFileToLoad(uft::String const&);
    //     void annotationChangeNotify(dplib::ContentRecordImpl*);
    //     void armTimer();
    //     void assignLocationAndSave(uft::sref<dplib::ContentRecordImpl> const&, uft::String const&);
    //     void assignLocationAndSave(uft::sref<dplib::ContentTagImpl> const&, uft::String const&);
    //     void cloneContentTag(dp::ref<dplib::ContentTag> const&);
    //     void cloneTree(mdom::Reference const&);
    //     void createContentTag(dp::String const&);
    //     void doSomeLoading();
    //     void ensureDomExists();
    //     void getAnnotationURLPrefix();
    //     void getContentURLPrefix();
    //     void getThumbnailURLPrefix();
    //     void handleBroadcastMessage(uft::String const&, uft::String const&);
    //     void itemRemoved(uft::sref<dplib::ContentRecordImpl> const&);
    //     void itemRemoved(uft::sref<dplib::ContentTagImpl> const&);
    //     void itemSaved(uft::sref<dplib::ContentRecordImpl> const&);
    //     void itemSaved(uft::sref<dplib::ContentTagImpl> const&);
    //     void libraryPartitionRemoved();
    //     void loadDirectory(uft::String const&);
    //     void loadFile(uft::String const&);
    //     void loadXML(unsigned int, dp::Data const&);
    //     void operationError(dp::String);
    //     void saveContentRecord(dplib::ContentRecordImpl*);
    //     void saveContentTag(dplib::ContentTagImpl*);
    //     void saveDirtyContentRecords();
    //     void saveDirtyTags();
    //     void shouldSaveContentRecord(dplib::ContentRecordImpl*, bool);
    //     void staticInit();
    //     void thumbnailChangeNotify(dplib::ContentRecordImpl*);

    //     void* s_descriptor;

    // };

    // class RemoveFileCallback<dplib::ContentRecordImpl>: public dp::Callback
    // {
    // public:
    //     virtual ~RemoveFileCallback();
    //     virtual void reportError(dp::String const&);
    //     virtual void invoke(dp::Unknown*);

    // };

    // class RemoveFileCallback<dplib::ContentTagImpl>: public dp::Callback
    // {
    // public:
    //     virtual ~RemoveFileCallback();
    //     virtual void reportError(dp::String const&);
    //     virtual void invoke(dp::Unknown*);

    // };

    // class TagList: public dp::List<dplib::ContentTag>
    // {
    // public:
    //     virtual ~TagList();
    //     virtual void addRef();
    //     virtual void release();
    //     virtual void length();
    //     virtual void operator[](unsigned int);

    // };

    // class WriteFileCallback<dplib::ContentRecordImpl>: public dp::Callback
    // {
    // public:
    //     virtual ~WriteFileCallback();
    //     virtual void reportError(dp::String const&);
    //     virtual void invoke(dp::Unknown*);

    // };

    // class WriteFileCallback<dplib::ContentTagImpl>: public dp::Callback
    // {
    // public:
    //     virtual ~WriteFileCallback();
    //     virtual void reportError(dp::String const&);
    //     virtual void invoke(dp::Unknown*);

    // };


}



#endif // _DPLIB_H
