/*
    File automatically generated by SOAdvancedDissector.py
    More information at http://indefero.soutade.fr/p/soadvanceddissector
*/

#ifndef _DPUTILS_H
#define _DPUTILS_H

#include <dp.h>
#include <adept.h>

namespace dpio {
    class StreamClient;
    class Stream: public dp::Releasable
    {
    public:
        virtual ~Stream();
        virtual void* getInterfaceID();
        virtual void release() = 0;
        virtual void setStreamClient(dpio::StreamClient*) = 0;
        virtual int getCapabilities() = 0;
        virtual void requestInfo() = 0;
        virtual void requestBytes(unsigned int, unsigned int) = 0;
        virtual void reportWriteError(dp::String const&) = 0;
        virtual void adjustModifiedStream();

        static dpio::Stream* createDataStream(dp::String const&, dp::Data const&, dpio::StreamClient*, dp::Callback*);
        static dpio::Stream* createDataURLStream(dp::String const&, dpio::StreamClient*, dp::Callback*);
	static dp::Data readSynchronousStream(dpio::Stream*);

    };
}

namespace dputils {

    class GuardedObject;
    class GuardedStream;

    class GuardedObject
    {
    public:
        GuardedObject();

        virtual void release();
        virtual void virtfunc12() = 0;

    };

    class GuardedStream: public dpio::Stream, public dputils::GuardedObject
    {
    public:
        virtual ~GuardedStream();
        virtual void release();
        virtual void setStreamClient(dpio::StreamClient*);
        virtual int getCapabilities() = 0;
        virtual void requestInfo() = 0;
        virtual void requestBytes(unsigned int, unsigned int) = 0;
        virtual void reportWriteError(dp::String const&) = 0;
        virtual void propertiesReady() = 0;

    };


}



#endif // _DPUTILS_H
